program flames;
uses objgfx8,keys;
type Tflame=object(Tgfx8)
      Screen:TScreen8;
      firebuf:array[0..160*120-1] of byte;
      constructor init;
      procedure run;
      destructor done; virtual;
     end;
var Flame:^Tflame;

constructor TFlame.Init;
begin
 inherited init;
 getmem(160,120);
 Screen.Init;
 screen.SetupMode(_320x200x8bpp);
 screen.loadpal('flames.pal');
 screen.makepal;
 randomize
end;

procedure TFlame.Run;
var x,y,pix:word;
begin
  repeat
  for y:=1 to getmaxy-1 do
   for x:=1 to getmaxx-1 do
    begin
     pix:=getpixel(x,y);
     inc(pix,getpixel(x-1,y));
     inc(pix,getpixel(x+1,y));
     inc(pix,getpixel(x,y+1));
     pix:=pix shr 2;
     if pix=0 then putpixel(x,y-1,0) else putpixel(x,y-1,pix-1);
    end;
   for x:=0 to getmaxx do
    begin
     putpixel(x,getmaxy,255*(random(255) and 1));
     putpixel(x,getmaxy-1,255*(random(255) and 1));
    end;
  screen.flip(self);
{ screen.scalebuf(0,0,screen.getmaxx,screen.getmaxy,self,0,0,getmaxx,getmaxy-2);}
 until keypressed;
 readkey;
end;

destructor TFlame.Done;
begin
 inherited done;
 Screen.Done;
end;

(*
procedure flamer; assembler;
asm
	mov	cx,80*122
	lea	si,[flame+81]
@lop1:	xor	ax,ax
	xor	bx,bx
	mov	al,[si-1]
	mov	bl,[si]
	add	ax,bx
	mov	bl,[si+1]
	add	ax,bx
	mov	bl,[si+80]
	add	ax,bx
	shr	ax,2
	jz	@ddx
	dec	ax
@ddx:	mov	[si-81],al ;{The 81 makes the flames appear to move <-}
	inc	si
	loop	@lop1
	lea	si,[flame+122*80]
        mov	cx,40
@lop2:  call	rand
        test	ax,1
        jz	@even
    	xor	ax,ax
        jmp	@strange
@even:	mov	ax,65535
@strange:mov	[si],ax
        add	si,2
	loop	@lop2
        call    wfr;
	lea	si,[flame]
	mov	ax,0a000h
	mov	es,ax
        xor	di,di
	mov	cx,(4800-120)/2
        db 66h; rep movsw
end;

procedure flamer2; assembler;
asm

	mov	cx,80*122
	lea	si,[flame+81]
@lop1:	xor	ax,ax
	xor	bx,bx
	mov	al,[si-1]
	mov	bl,[si]
	add	ax,bx
	mov	bl,[si+1]
	add	ax,bx
	mov	bl,[si+80]
	add	ax,bx
	shr	ax,2
	jnz	@ddx
	dec	ax
@ddx:	mov	[si-81],al;{The 81 makes the flames appear to move right2left}
	inc	si
	loop	@lop1
	lea	si,[flame+123*80]
        mov	cx,40
@lop2:  call	rand
        test	ax,1
        jz	@even
    	xor	bx,bx
        jmp	@strange
@even:	mov	bx,65535
@strange:mov	[si],bx
        mov	[si-80],bx
        add	si,2
	loop	@lop2
	lea	si,[flame]
        call    wfr;
	mov	ax,0a000h
	mov	es,ax
        xor	di,di
	mov	cx,(4800-120)/2
	db	0f3h
        db	66h
	db      0a5h           {This is rep movsd}
end;
*)
begin
 new(Flame,init);
 Flame^.Run;
 dispose(Flame,Done);
end.