program PCX2MSH;
uses ObjGfx0,objgfx8,dos;
var buf:Tgfx8;
    source,dest:string;

function fexist(const filename:string):boolean; {return true if exist}
var DirInfo:SearchRec;
begin
 findfirst(filename,AnyFile,DirInfo);
 fexist:=(DosError=0)
end;

begin
 if (paramcount<>2) then
  begin
   write('Source file: ');
   readln(source);
   write('Dest file: ');
   readln(dest);
  end
 else
  begin
   source:=paramstr(1);
   dest:=paramstr(2);
  end;
 if dest='' then
  begin
   writeln('Invalid destination file');
   halt
  end;

 if not fexist(source) then
  begin
   writeln('Could not open source file');
   halt
  end;

 buf.init;
 if not buf.loadgfx(source) then
  begin
   writeln('Error loading file: ',source);
   halt
  end;
 buf.savegfx(dest,MSH);
 buf.done;
 writeln('Done.');
end.