program scroll;
uses objgfx8,keys;
var buf:Tgfx8;
    screen:TScreen8;
    count:word;
begin
 with screen do
 begin
  init;
  if not IsVesaInstalled=VESA_ok then
   begin
    writeln('No VESA BIOS');
    halt
   end;
  if not IsModeAvailable(_640x480x8bpp) then
   begin
    writeln('Cannot init 640x480x8bpp');
    halt
   end;
  buf.init;
  if not buf.loadgfx('sphere.msh') then
   begin
    writeln('Error loading graphic: sphere.msh');
    halt
   end;
  if not setmode(_640x480x8bpp) then {this is redundant}
   begin
    writeln('Error setting 640x480x8bpp');
    halt
   end;
  pal:=buf.pal;
  makepal;
  SetKbdInterrupt;
  for count:=getmaxy downto 0 do
   begin
    copybuf(0,count,buf,0,0,buf.getmaxx,screen.getmaxy-count);
    waitforretrace;
   end;
  readkey;
  count:=0;
  repeat
   inc(count,2);
   scalebuf(0,count,getmaxx,getmaxy-count,buf,0,0,buf.getmaxx,buf.getmaxy);
   bar(0,count-2,getmaxx,count,0);
   bar(0,getmaxy-count,getmaxx,getmaxy-count+2,0);
   waitforretrace
  until count>=(getmaxy div 2);
  RestoreKbdINterrupt;
  buf.done;
  done
 end
end.