uses dos,ObjGfx0,objgfx8,keys;
var screen:TScreen8;
    pic:TGfx8;
    ky:byte;
    picstr:string;
    t1,t2:longint;

begin
 if paramcount<>1 then
  begin
   writeln('Usage: ShowGFX <filename>');
   writeln('Supported File types are MSH, PCX, DNY, BMP, LBM');
   writeln('During:');
   writeln('F5: display in 320x200x8bpp');
   writeln('F6: display in 640x400x8bpp');
   writeln('F7: display in 640x480x8bpp');
   writeln('F8: display in 800x600x8bpp');
   writeln('F9: display in 1024x768x8bpp');
   writeln('F10: display in 1280x1024x8bpp');
   halt
  end;
 picstr:=paramstr(1);
 if fsearch(picstr,'')='' then
  begin
   writeln('File not found: ',paramstr(1));
   halt
  end;
 pic.init;
 if not pic.loadgfx(picstr) then
  begin
   writeln('Error loading GFX file');
   halt
  end;
 screen.init;
 screen.SetupMode(_640x480x8bpp); {start out in 640x480x256}
 screen.pal:=pic.pal;
 screen.makepal;
 SetKbdInterrupt;
 with screen do
 repeat
  if (getmaxx>=pic.getmaxx) and (getmaxy>=pic.getmaxy) then
   copybuf((getmaxx-pic.getmaxx) shr 1,(getmaxy-pic.getmaxy) shr 1,pic,
           0,0,pic.getmaxx,pic.getmaxy)
  else flip(pic);
  ky:=readScanCode;
  case ky of
   KY_F5:SetupMode(_320x200x8bpp); {320x200x256.. this is always available}
   KY_F6:SetMode(_640x400x8bpp);
   KY_F7:SetMode(_640x480x8bpp);
   KY_F8:SetMode(_800x600x8bpp);
   KY_F9:SetMode(_1024x768x8bpp);
  KY_F10:SetMode(_1280x1024x8bpp);
  end;
  screen.pal:=pic.pal;
  MakePal;
 until ky=KY_ESC;
 RestoreKbdInterrupt;
 Pic.Done;
 Screen.Done;
end.