{
SpinDisk by WILLIAM SITCH

Adapted (from SWAG) by TCA of NewOrder
}

Uses
 ObjGfx0,ObjGfx8,keys;

var screen:TScreen8;

Procedure spin_disk;
Var
  p, op    :  array[1..4] of PointType;  {op=old position}
  cx, cy,x, y,i,rot,tempx,tempy:Integer;
  theta    :  Real;
  down     :  Boolean;
  del      :  word;

begin
  cx := screen.getmaxx div 2;
  cy := screen.getmaxy div 2;
  screen.circle(cx,cy,150,15);

  rot := 0;
  p[1].x := 100;  p[1].y := 0;
  p[2].x := 0;    p[2].y := -100;
  p[3].x := -100; p[3].y := 0;
  p[4].x := 0;    p[4].y := 100;

  del := 2;
  down := True;
  SetKbdINterrupt;
  with screen do
  Repeat
    inc(rot,2);
    theta := rot * 3.14 / 180;
    For i := 1 to 4 do
      begin
        tempx := p[i].x;
        tempy := p[i].y;
        op[i].x := p[i].x;
        op[i].y := p[i].y;
        p[i].x := round(cos(theta) * tempx - sin(theta) * tempy);
        p[i].y := round(sin(theta) * tempx + cos(theta) * tempy);
      end;
    for i:=low(op) to high(op) do
     begin
      inc(op[i].x,cx);
      inc(op[i].y,cy);
      line(op[i].x,op[i].y,cx,cy,0);
     end;
    drawpoly(4,op,0);

    For i := 1 to 4 do
    line(p[1].x + cx,cy + p[1].y,p[2].x + cx,cy + p[2].y,11);
    line(p[2].x + cx,cy + p[2].y,p[3].x + cx,cy + p[3].y,11);
    line(p[3].x + cx,cy + p[3].y,p[4].x + cx,cy + p[4].y,11);
    line(p[4].x + cx,cy + p[4].y,p[1].x + cx,cy + p[1].y,11);
    For i := 1 to 4 do
      line(p[i].x + cx,cy + p[i].y,cx,cy,10);

    if (del < 1) then down := False
     else if (del > 2) then down := True;
    if (down) then dec(del) else inc(del);
    for i:=0 to del do
     screen.waitforretrace; {slight delay}
  Until (KeyPressed);
 RestoreKbdINterrupt;
end;

begin
 Screen.init;
 with screen do  {Do some simple error checking}
  begin
   if not IsVesaInstalled=VESA_ok then
    begin
     writeln('No VESA BIOS');
     halt
    end;
   if not SetMode(_640x480x8bpp) then
    begin
     writeln('Cannot init 640x480x8bpp');
     halt
    end
  end;
  Spin_disk;
  Screen.done;
end.