program wavy; { WAVY.PAS }
{ Small demo for the 'use' of sine-tables, by Bas van Gaalen
  modified for high-res by TCA of NewOrder}
uses objgfx8,keys;

const
  add1=1; add2=-1; add3=-1;
var
  ptab,ctab:array[0..1023] of byte;
  stab1,stab2,stab3:array[0..255] of byte;
  i,i1,i2,i3:word;
  screen:TScreen8;
begin
 screen.init;
 screen.setupmode(_800x600x8bpp);
 setkbdinterrupt;
 for i:=0 to 255 do
  begin
   stab1[i]:=round(sin(i*2*pi/255)*50)+99;
   stab2[i]:=round(cos(i*4*pi/255)*25);
   stab3[i]:=round(sin(i*4*pi/255)*25);
 end;
 fillchar(ctab,sizeof(ctab),0);
  for i:=1 to 199 do screen.setrgbpalette(i,i div 3,20+i div 5,10+i div 6);
  i1:=0; i2:=25; i3:=100;
  repeat
   move(ctab,ptab,sizeof(ctab));
   screen.waitforretrace;
   for i:=0 to screen.getmaxx do
    begin
     ctab[i]:=stab1[(i+i1) mod 255]+stab2[(i+i2) mod 255]+stab3[(i+i3) mod 255];
     screen.putpixel(i,ptab[i]+200,0);
     screen.putpixel(i,ctab[i]+200,ctab[i]);
    end;
   i1:=(i1+add1) mod 255; i2:=(i2+add2) mod 255; i3:=(i3+add3) mod 255;
  until keypressed;
 restorekbdinterrupt;
 screen.done;
end.
